Attribute VB_Name = "ENCONOR"
'***********************************************************************************
'*          Para poder utilizar este modulo de funciones, es necesario en el proyecto
'           del alumno un formulario llamado FormEnconor.
'*          En este formulario , como minimo, se incluira un objeto del tipo MSComm
'*          llamado Enconor, que se encarga de la comunicacion serie.
'************************************************************************************
'***********************************************************************************
'           Declaramos las variables globales o publicas, que se podran utilizar
'           en todo el proyecto.
'              Estas variables pdran ser consultadas por el alumno en cualquier
'           parte de su proyecto.
'***********************************************************************************

Public ValorSalidas As Integer      '***** Variable que almacena el valor de las salidas
Public ValorEntradas As Integer     '**** Variable que almacena el valor de las entradas
'********** Variables de las entradas Analogicas ************************************
Public ValorAnalogico1 As Integer   '** Almacena el ltimo valor Analogico tomado de la
                                    'entrada Analogica 1
Public ValorAnalogico2 As Integer
Public ValorAnalogico3 As Integer
Public ValorAnalogico4 As Integer
Public ValorAnalogico5 As Integer
'*************************************************************************************
Public SalidaAnalogica1 As Integer    ' Valores de los potenciometros digitales *****
Public SalidaAnalogica2 As Integer
Public SalidaAnalogica3 As Integer
Public SalidaAnalogica4 As Integer
Public NPuerto As Integer '***** Variable que almacena el numero del Puerto
Public canal As Integer



'*************************************************************************************

Function Conecta(Salida As Integer) As Boolean
'*********************************************************************************
'*    Esta funcion conecta la salida indicada en Salida
'*    Devuelve True si la operacion es correcta
'*    Devuelve False si la operacion es incorrecta
'**********************************************************************************
If Salida < 1 Or Salida > 8 Then
        Conecta = False
        Exit Function
        End If
If Salida = 1 Then ValorSalidas = ValorSalidas Or 1
If Salida = 2 Then ValorSalidas = ValorSalidas Or 2
If Salida = 3 Then ValorSalidas = ValorSalidas Or 4
If Salida = 4 Then ValorSalidas = ValorSalidas Or 8
If Salida = 5 Then ValorSalidas = ValorSalidas Or 16
If Salida = 6 Then ValorSalidas = ValorSalidas Or 32
If Salida = 7 Then ValorSalidas = ValorSalidas Or 64
If Salida = 8 Then ValorSalidas = ValorSalidas Or 128

If Enviar(ValorSalidas) = True Then
        Conecta = True
        Else
        Conecta = False
        End If
    
End Function
Function Apaga(Salida As Integer) As Boolean
'*********************************************************************************
'*    Esta funcion apaga la salida indicada en Salida
'*    Devuelve True si la operacion es correcta
'*    Devuelve False si la operacion es incorrecta
'**********************************************************************************

If Salida < 1 Or Salida > 8 Then
        Apaga = False
        Exit Function
        End If
If Salida = 1 Then ValorSalidas = ValorSalidas And 254
If Salida = 2 Then ValorSalidas = ValorSalidas And 253
If Salida = 3 Then ValorSalidas = ValorSalidas And 251
If Salida = 4 Then ValorSalidas = ValorSalidas And 247
If Salida = 5 Then ValorSalidas = ValorSalidas And 239
If Salida = 6 Then ValorSalidas = ValorSalidas And 223
If Salida = 7 Then ValorSalidas = ValorSalidas And 191
If Salida = 8 Then ValorSalidas = ValorSalidas And 127

If Enviar(ValorSalidas) = True Then
        Apaga = True
        Else
        Apaga = False
        End If
        
End Function
Function Enviar(Dato As Integer) As Boolean
'*********************************************************************************
'   Esta funcion envia a las salidas el valor de dato. Si la operacion es correcta
'   devuelve True y si no False
'   Actualiza la variable global ValorSalidas
'*********************************************************************************

Dim Entrada, OK, Enviarsalidas As String ' Variables locales de la funcion
'****** Permitimos Valores entre o y 255 **********************************
If Dato > 255 Or Dato < 0 Then
        Enviar = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
'***** Si no se ha detectado la tarjeta no envia las salidas
If NPuerto = 0 Or NPuerto = -1 Then
        Enviar = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
'*****************************************************************************
Enviarsalidas = Chr$(170)       ' Cod de operacion enviar salidas
OK = Chr$(240)
formEnconor.Enconor.Output = Enviarsalidas
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        Enviar = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        Enviar = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
        
    '**** enviamos el valor de las salidas ******
    formEnconor.Enconor.Output = Chr$(Dato)
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        Enviar = False             ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        Enviar = False              ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Enviar = True
    ValorSalidas = Dato
    End Function
Public Function Recibir() As Boolean
'*********************************************************************************
'   Esta funcion Recibe el valor de las entradas digitales.
'   Si la operacion es correcta devuelve True y sino False
'   Actualiza la variable global ValorEntradas
'*********************************************************************************

Dim Valor, Entrada, OK, RecibirEntradas As String
'***** Si no se ha detectado la tarjeta no recibe las entradas
If NPuerto = 0 Or NPuerto = -1 Then
        Recibir = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
'*****************************************************************************
RecibirEntradas = Chr$(204)
OK = Chr$(240)
formEnconor.Enconor.Output = RecibirEntradas
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        Recibir = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Valor = formEnconor.Enconor.Input
    '**** Enviamos de nuevo el valor de las entradas ******
    If Valor = "" Then
                    formEnconor.Enconor.Output = Chr$(0)
                    Else
                    formEnconor.Enconor.Output = Valor
                    End If
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        Recibir = False             ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        Recibir = False              ' Indica que no se ha enviado el dato
        Exit Function
        End If
    Recibir = True
    If Valor = "" Then
                    ValorEntradas = 0
                    Else
                    ValorEntradas = Asc(Valor)
                    End If
    End Function
    Function LeeAnalogica(Numero As Integer) As Boolean
'*********************************************************************************
'   Esta funcion Recibe el valor de la entrada Analogica indicada en Numero
'   Si la operacion es correcta
'   devuelve True y sino False.
'   Actualiza las variables globales
'   ValorAnalogico1 ValorAnalogico2 ValorAnalogico3 ValorAnalogico4 ValorAnalogico5
'*********************************************************************************

Dim Valor, Entrada, OK, RecibirEntradas As String
'*********** comprobamos el numero de la Entrada Analogica ************************
If Numero < 1 Or Numero > 5 Then
        LeeAnalogica = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If

'***** Si no se ha detectado la tarjeta no recibe las entradas
If NPuerto = 0 Or NPuerto = -1 Then
        LeeAnalogica = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
'*****************************************************************************
RecibirAnalogica = Chr$(195)
OK = Chr$(240)
formEnconor.Enconor.Output = RecibirAnalogica
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        LeeAnalogica = False          ' Indica error en la comunicacion
        Exit Function
        End If
    
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        LeeAnalogica = False           ' Indica error en la comunicacion
        Exit Function
        End If
    
    formEnconor.Enconor.Output = Chr$(Numero)
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        LeeAnalogica = False          ' Indica error en la comunicacion
        Exit Function
        End If
    Valor = formEnconor.Enconor.Input
    If Valor = "" Then Valor = Chr$(0)
    If Numero = 1 Then ValorAnalogico1 = Asc(Valor)
    If Numero = 2 Then ValorAnalogico2 = Asc(Valor)
    If Numero = 3 Then ValorAnalogico3 = Asc(Valor)
    If Numero = 4 Then ValorAnalogico4 = Asc(Valor)
    If Numero = 5 Then ValorAnalogico5 = Asc(Valor)
    LeeAnalogica = True
    End Function
    Function SalidaAnalogica(Numero As Integer, Posicion As Integer) As Boolean
'*********************************************************************************
'   Esta funcion escribe en el potenciometro Numero , el valor dado en Posicion
'   Si la operacion es correcta
'   devuelve True y sino False.
'   Actualiza las variables globales
'   Potencimetro1 Potencimetro2 Potencimetro3 Potencimetro4
'*********************************************************************************

Dim Valor, Entrada, OK, EscribirPotenciometro As String
'*********** comprobamos el numero de la Entrada Analogica ************************
If Numero < 1 Or Numero > 4 Then
        SalidaAnalogica = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
If Posicion < 0 Or Posicion > 255 Then
        SalidaAnalogica = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If

'***** Si no se ha detectado la tarjeta no recibe las entradas
If NPuerto = 0 Or NPuerto = -1 Then
        SalidaAnalogica = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
'*****************************************************************************
EscribirPotenciometro = Chr$(60)
OK = Chr$(240)
formEnconor.Enconor.Output = EscribirPotenciometro
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        SalidaAnalogica = False          ' Indica error en la comunicacion
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        SalidaAnalogica = False           ' Indica error en la comunicacion
        Exit Function
        End If
    
    formEnconor.Enconor.Output = Chr$(Numero)
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        SalidaAnalogica = False          ' Indica error en la comunicacion
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        SalidaAnalogica = False           ' Indica error en la comunicacion
        Exit Function
        End If
    
    formEnconor.Enconor.Output = Chr$(Posicion)
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    If Contador = 5000 Then
        SalidaAnalogica = False          ' Indica error en la comunicacion
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada <> OK Then
        SalidaAnalogica = False           ' Indica error en la comunicacion
        Exit Function
        End If
    SalidaAnalogica = True
    If Numero = 1 Then SalidaAnalogica1 = Posicion
    If Numero = 2 Then SalidaAnalogica2 = Posicion
    If Numero = 3 Then SalidaAnalogica3 = Posicion
    If Numero = 4 Then SalidaAnalogica4 = Posicion
    End Function
Function Voltaje(Numero As Integer, Valor As Double) As Boolean
'***********************************************************************************
'       Obtiene por la salida analgica indicada en Numero, la tension indicada por
'       la variable Valor.
'       LLama a la funcion potenciometro
'************************************************************************************

Dim Posicion As Integer
If Numero < 1 Or Numero > 4 Then
        Voltaje = False          ' Indica que no se ha enviado el dato
        Exit Function
        End If
Posicion = Int(Valor * 255 / 11.05)
If SalidaAnalogica(Numero, Posicion) = True Then
                    Voltaje = True
                    Exit Function
                    End If
Voltaje = False
End Function
Function Entrada(NEntrada As Integer) As Boolean
'************************************************************************************
'*   Comprueba el estado de la entrada indicada en NEntrada y devuelve True o False en funcion
'*   de su valor
'*************************************************************************************
If NEntrada < 1 Or NEntrada > 8 Then
        Entrada = False
        Exit Function
        End If
Recibir
If NEntrada = 1 Then
            If (ValorEntradas And 1) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 2 Then
            If (ValorEntradas And 2) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 3 Then
            If (ValorEntradas And 4) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 4 Then
            If (ValorEntradas And 8) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 5 Then
            If (ValorEntradas And 16) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 6 Then
            If (ValorEntradas And 32) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 7 Then
            If (ValorEntradas And 64) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If
If NEntrada = 8 Then
            If (ValorEntradas And 128) = 0 Then
            Entrada = False
            Else
            Entrada = True
            End If
            Exit Function
End If

End Function
Function DetectarPuerto1() As Integer
'****************************************************************************
' Detectamos el puerto de comunicaciones donde esta conectada la placa
' Salida de la Funcion
'           -1 : Indica que no se ha detectado la placa controladora
'            1 : La tarjeta controladopra esta en el puerto com 1
'            2 : La tarjeta controladora esta en el pueryto com 2
'****************************************************************************
Dim Atencion, Entrada, OK As String
Dim Contador As Variant
On Error GoTo RutinaError
    NPuerto = -1    '**** Inicialmente se coloca a puerto no detectado
    ' Utiliza COM1.
    ' Configuramos los parametros de comunicacion
    Atencion = Chr$(255)
    OK = Chr$(240)
    formEnconor.Enconor.CommPort = 1

    If formEnconor.Enconor.PortOpen = False Then
        formEnconor.Enconor.CommPort = 1
        ' 9600 baudios, sin paridad, 8 bits de datos y 1    ' bit de parada.
        formEnconor.Enconor.Settings = "9600,N,8,1"
        ' Indicar al control que lea todo el bfer al usar  ' Input.
        formEnconor.Enconor.InputLen = 0
        ' Abrir el puerto.
        formEnconor.Enconor.PortOpen = True
    End If
    ' Enviar a la  placa el comando de atencion.
    formEnconor.Enconor.Output = Atencion
    Contador = 0
    '***** Esperamos para recibir contestacion por el puerto serie
    Contador = 0
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    
    If Contador = 5000 Then
        DetectarPuerto1 = -1
        formEnconor.Enconor.PortOpen = False
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada = OK Then
        DetectarPuerto1 = 1
        NPuerto = 1
        Else
        DetectarPuerto1 = -1
        End If
    Exit Function
    
RutinaError:
        DetectarPuerto1 = -1
        On Error GoTo 0
        Exit Function
        
End Function
Function DetectarPuerto2() As Integer
'****************************************************************************
' Detectamos el puerto de comunicaciones donde esta conectada la placa
' Salida de la Funcion
'           -1 : Indica que no se ha detectado la placa controladora
'            1 : La tarjeta controladopra esta en el puerto com 1
'            2 : La tarjeta controladora esta en el pueryto com 2
'****************************************************************************
Dim Atencion, Entrada, OK As String
Dim Contador As Variant
On Error GoTo RutinaError1

    NPuerto = -1    '**** Inicialmente se coloca a puerto no detectado
    ' Utiliza COM1.
    ' Configuramos los parametros de comunicacion
    Atencion = Chr$(255)
    OK = Chr$(240)
    formEnconor.Enconor.CommPort = 2
    If formEnconor.Enconor.PortOpen = False Then
        formEnconor.Enconor.CommPort = 2
        ' 9600 baudios, sin paridad, 8 bits de datos y 1    ' bit de parada.
        formEnconor.Enconor.Settings = "9600,N,8,1"
        ' Indicar al control que lea todo el bfer al usar  ' Input.
        formEnconor.Enconor.InputLen = 0
        ' Abrir el puerto.
        formEnconor.Enconor.PortOpen = True
    End If
    ' Enviar a la  placa el comando de atencion.
    formEnconor.Enconor.Output = Atencion
    Contador = 0
    '***** Esperamos para recibir contestacion por el puerto serie
    
    Do
        Contador = Contador + 1
    Loop Until formEnconor.Enconor.InBufferCount = 1 Or Contador = 5000
    '***************************************************************
    
    If Contador = 5000 Then
        DetectarPuerto2 = -1
        formEnconor.Enconor.PortOpen = False
        Exit Function
        End If
    Entrada = formEnconor.Enconor.Input
    If Entrada = OK Then
        DetectarPuerto2 = 2
        NPuerto = 2
        Else
        DetectarPuerto2 = -1
        End If
    Exit Function
RutinaError1:
        DetectarPuerto2 = -1
        On Error GoTo 0
        Exit Function
End Function

Function DetectarPuerto() As Integer
'*************************************************************************************
'       Chequeamos el puerto com1 y luego el com2

' Salida de la Funcion
'           -1 : Indica que no se ha detectado la placa controladora
'            1 : La tarjeta controladopra esta en el puerto com 1
'            2 : La tarjeta controladora esta en el pueryto com 2
'****************************************************************************
If DetectarPuerto1 = 1 Then
            DetectarPuerto = 1
            Exit Function
            End If
If DetectarPuerto2 = 2 Then
            DetectarPuerto = 2
            Exit Function
            End If
DetectarPuerto = -1
End Function
